﻿Imports System.Data.SqlServerCe
Public Class frm_kundeneu
    Private rnd As Random = New Random()
    Private i_kdnummer As Integer
    Private s_kdnummer As String
    Private KdNr As String
    Private Sub SetSQL(ByVal SQL As String)
        Dim conn As New SqlCeConnection
        Dim cmd As New SqlCeCommand
        conn.ConnectionString = "datasource=B:\Dokumente\EAR\EAR\DB_1.sdf"
        cmd.Connection = conn
        cmd.CommandText = SQL
        conn.Open()
        cmd.ExecuteNonQuery()
        conn.Close()
    End Sub
    Private Sub GetSQL(ByVal SQL As String)
        Dim conn As New SqlCeConnection
        Dim cmd As New SqlCeCommand
        conn.ConnectionString = "datasource=B:\Dokumente\EAR\EAR\DB_1.sdf"
        cmd.Connection = conn
        cmd.CommandText = SQL
        Dim da As New SqlCeDataAdapter(cmd)
        Dim dt As New DataTable
        conn.Open()
        da.Fill(dt)
        conn.Close()
        KUAD_View.DataSource = dt
    End Sub
    Private Sub dataview()
        GetSQL("SELECT Kunden.KdNr, Kunden.KdVorname, Kunden.KdNachname, Kunden.KdeMail, Kunden.KdTel, Kunden.KdInstagram, Address.PLZ, Address.Stadt, Address.Strasse, Address.Nr FROM Kunden JOIN KUAD ON Kunden.ID = KUAD.ID_Kunden JOIN Address ON KUAD.ID_Address = Address.ID")
    End Sub
    Private Sub Kundennummer()
        i_kdnummer = rnd.[Next](1000, 100000)
        Dim vn As String = KdVornameTextBox.Text
        Dim nn As String = KdNachnameTextBox.Text
        KdNr = vn.Substring(0, 1) & nn.Substring(0, 1) & "-" & i_kdnummer
        KdNrTextBox.Text = KdNr
    End Sub
    Private Sub textboxoff()
        For Each TextBox In Me.Controls.OfType(Of TextBox)() : TextBox.Enabled = False : Next
    End Sub
    Private Sub Textboxon()
        For Each TextBox In Me.Controls.OfType(Of TextBox)() : TextBox.Enabled = True : Next
    End Sub
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        textboxoff()
        Timer1.Stop()
    End Sub
    Private Sub counters()
        With Me.BindingContext(Me.DB1ds.Kunden)
            lbl_counters.Text = "Datensatz " & (Me.KundenBindingSource.Position + 1).ToString & " von " & .Count.ToString & " Datensätzen."
        End With
        dataview()
    End Sub
    Private Sub speichern()
        Me.Validate()
        Me.KundenBindingSource.EndEdit()
        Me.AddressBindingSource.EndEdit()
        Me.KuAdBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.DB1ds)
        counters()
    End Sub
    Private Sub frm_kundeneu_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.AddressTableAdapter.Fill(Me.DB1ds.Address)
        Me.KundenTableAdapter.Fill(Me.DB1ds.Kunden)
        Me.KuadTableAdapter.Fill(Me.DB1ds.KUAD)
        counters()
        buttons()
        textboxoff()
        dataview()
    End Sub
    Private Sub btn_save_Click(sender As Object, e As EventArgs) Handles btn_save.Click
        Kundennummer()
        speichern()
        textboxoff()
        buttons()
    End Sub
    Private Sub buttons()
        If KundenBindingSource.Count = Nothing Then btnKuAdneu.Enabled = False Else btnKuAdneu.Enabled = True
        If KundenBindingSource.Count = Nothing Then btnKuAdsave.Enabled = False Else btnKuAdsave.Enabled = True
        If KuAdBindingSource.Count = Nothing Then btnKuAdsave.Enabled = False Else btnKuAdsave.Enabled = True
        If KundenBindingSource.Count = Nothing Then btn_delete.Enabled = False Else btn_delete.Enabled = True
        If KundenBindingSource.Count = Nothing Or IDTextBox.Text = "" Then btn_save.Enabled = False Else btn_save.Enabled = True
    End Sub
    Private Sub btn_new_Click(sender As Object, e As EventArgs) Handles btn_new.Click
        Textboxon()
        btn_save.Enabled = True
        Me.AddressBindingSource.AddNew()
        Me.KundenBindingSource.AddNew()
        Me.TableAdapterManager.UpdateAll(Me.DB1ds)
    End Sub
    Private Sub btn_prev_Click(sender As Object, e As EventArgs) Handles btn_prev.Click
        Me.KundenBindingSource.MovePrevious()
        Me.AddressBindingSource.MovePrevious()
        counters()
    End Sub
    Private Sub btn_next_Click(sender As Object, e As EventArgs) Handles btn_next.Click
        Me.KundenBindingSource.MoveNext()
        Me.AddressBindingSource.MoveNext()
        counters()
    End Sub
    Private Sub btn_delete_Click(sender As Object, e As EventArgs) Handles btn_delete.Click
        Me.KundenBindingSource.RemoveCurrent()
        Me.AddressBindingSource.RemoveCurrent()
        Me.TableAdapterManager.UpdateAll(Me.DB1ds)
        counters()
        buttons()
    End Sub
    Private Sub btnKuAdneu_Click_1(sender As Object, e As EventArgs) Handles btnKuAdneu.Click
        btnKuAdsave.Enabled = True
        Me.KuAdBindingSource.AddNew()
    End Sub
    Private Sub btnKuAdsave_Click(sender As Object, e As EventArgs) Handles btnKuAdsave.Click
        btnKuAdsave.Enabled = False
        Dim kunde As Integer = Convert.ToInt32(cboKunde.SelectedValue)
        Dim adresse As Integer = Convert.ToInt32(cboAdresse.SelectedValue)
        Dim dv As DataRowView = CType(Me.KuAdBindingSource.Current, DataRowView)
        dv(0) = kunde
        dv(1) = adresse
        speichern()
    End Sub

    ' 2 Dummy-User
    Private Sub btn_dummy_Click(sender As Object, e As EventArgs) Handles btn_dummy.Click
        KdeMailTextBox.Text = "maxmu@outdoor.nl"
        KdInstagramTextBox.Text = "@maxmu"
        KdNachnameTextBox.Text = "Mustermann"
        KdTelTextBox.Text = "01543423673"
        KdVornameTextBox.Text = "Max"
        PLZTextBox.Text = "48345"
        StadtTextBox.Text = "Fakecity"
        StrasseTextBox.Text = "Sackgasse"
        NrTextBox.Text = "12a"
    End Sub
    Private Sub btn_dummy1_Click(sender As Object, e As EventArgs) Handles btn_dummy1.Click
        KdeMailTextBox.Text = "janedo@indoor.nl"
        KdInstagramTextBox.Text = "@1janwdw"
        KdNachnameTextBox.Text = "Dowe"
        KdTelTextBox.Text = "0167348924"
        KdVornameTextBox.Text = "Jane"
        PLZTextBox.Text = "26544"
        StadtTextBox.Text = "Faketown"
        StrasseTextBox.Text = "Im Abgrund"
        NrTextBox.Text = "23"
    End Sub
End Class
